#include "juego.h"

using namespace STDP;

void Juego::iniciarJuego(int modo){ // modo es el tipo de partida seleccionada desde el menu principal
	StdPijo& stdp = StdPijo::p();
	stdp.init();

	modoSeleccionado=modo;
	bool findeljuego = 0;
	mostrarCuentaAtras();
	generarBackgroundAleatorio();
	navesParaAbatir=incrementoNaves+(nivelActual-1); //Fórmula para calcular el bonus del nivel

	int i = 0;
	do{
		teclapulsada=stdp.getKey();
		controlPersonaje();
		gestionarDisparo();
		gestionarEnemigo();
		gestionarObjetos();

		i++;
		usleep(10000);
		if(i == 2){
			stdp.clearScreen();
			mostrarEnergia();
			mostrarPuntuacion();
			mostrarBackground();
			mostrarDisparo();
			mostrarEnemigo();
			mostrarObjetos();

			stdp.refreshScr();
			i=0;
		}


		if(navesAbatidas==navesParaAbatir){
			navesParaAbatir=incrementoNaves+(nivelActual-1); //Fórmula para calcular el bonus del nivel
			navesAbatidas=0;
			nivelActual++;
			if(nivelActual % 3 == 0){
				if(tiempoEsperaRapidos>0)
					tiempoEsperaRapidos--;
				if(tiempoEsperaLentos>3);
					tiempoEsperaLentos--;
				if(tiempoEsperaNormales>7)
					tiempoEsperaNormales--;
			}
		}

		if(energia==0)
			findeljuego=true;


	}while(findeljuego==false);
}

void Juego::mostrarCuentaAtras(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.clearScreen();
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(36,11);
	stdp.writeStr("Ready?");
	stdp.refreshScr();
	sleep(1);
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.clearScreen();
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(33,11);
	stdp.writeStr("Really ready?");
	stdp.refreshScr();
	sleep(1);
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.clearScreen();
	stdp.setColor(ABOLD, CGREEN, CBLACK);
	stdp.setCursor(38,11);
	stdp.writeStr("GO!");
	stdp.refreshScr();
	sleep(1);
}

void Juego::mostrarEnergia(){
	int energiaPorPantalla=0;
	StdPijo& stdp = StdPijo::p();

	stdp.init();

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(16,23);
	stdp.writeStr("             ");
	stdp.setCursor(16,23);
	stdp.writeStr("Energia: ");
	energiaPorPantalla = energia/10;
	stdp.setColor(ANORMAL, CWHITE, CWHITE);
	for(int i = 0; i<energiaPorPantalla; i++){
		stdp.writeChar(' ');
	}

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(1,23);
	stdp.writeStr("             ");
	if(disparoGrande == true){
		stdp.setCursor(1,23);
		stdp.writeStr("BIG BOMB");
	}

}

void Juego::mostrarPuntuacion(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(45,23);
	stdp.writeStr("                   ");
	stdp.setCursor(45,23);
	stdp.writeStr("Puntuacion: ");
	char* puntuacionConvertida;
	puntuacionConvertida = new char[8];
	sprintf(puntuacionConvertida,"%d",puntuacionPartida);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(puntuacionConvertida);

}

void Juego::generarBackgroundAleatorio(){
	for(int i = 0; i<50; i++){
		posicionEstrellas[i][0]=rand() % 79;
		posicionEstrellas[i][1]=rand() % 22;
	}
}

void Juego::mostrarBackground(){

	StdPijo& stdp = StdPijo::p();
	stdp.init();


	stdp.setColor(ANORMAL,CYELLOW,CBLACK);
	for(int i = 0; i<50; i++){
		stdp.setCursor(posicionEstrellas[i][0],posicionEstrellas[i][1]);
		stdp.writeChar('*');
	}

	if(tiempoEsperaBackground == 0){
		for(int i = 0; i<50; i++){
			if(posicionEstrellas[i][0]>0)
				posicionEstrellas[i][0]--;
			else
				posicionEstrellas[i][0]=79;
		}
		tiempoEsperaBackground = 20;
	}

	else
		tiempoEsperaBackground--;

}

void Juego::controlPersonaje(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	stdp.setColor(ABOLD,CGREEN,CBLACK);
	stdp.setCursor(posicionJugador[0],posicionJugador[1]);
	stdp.writeChar('3');
	stdp.setColor(ABOLD,CCYAN,CBLACK);
	stdp.writeChar('(');
	stdp.setColor(ABOLD,CYELLOW,CBLACK);
	stdp.writeStr("oo");
	stdp.setColor(ABOLD,CCYAN,CBLACK);
	stdp.writeChar(')');
	stdp.setColor(ABOLD,CCYAN,CBLACK);
	stdp.writeChar('{');


	if(teclapulsada==KESCAPE){
		stdp.setColor(ABOLD,CGREEN,CBLACK);
		stdp.setCursor(65,23);
		stdp.writeStr("*PAUSA*");
		do{
		}while(stdp.getKey()!=KESCAPE);
		stdp.setColor(ABOLD,CGREEN,CBLACK);
		stdp.setCursor(65,23);
		stdp.writeStr("       ");
	}

	if(teclapulsada==KRIGHT && posicionJugador[0]!=74){
		stdp.setColor(ABOLD,CWHITE,CBLACK);
		stdp.setCursor(posicionJugador[0],posicionJugador[1]);

		posicionJugador[0]++;
	}
	else if(teclapulsada==KLEFT && posicionJugador[0]!=0){
		stdp.setColor(ABOLD,CWHITE,CBLACK);
		stdp.setCursor(posicionJugador[0],posicionJugador[1]);

		posicionJugador[0]--;
	}
	else if(teclapulsada==KUP && posicionJugador[1]!=0){
		stdp.setColor(ABOLD,CWHITE,CBLACK);
		stdp.setCursor(posicionJugador[0],posicionJugador[1]);

		posicionJugador[1]--;

	}
	else if(teclapulsada==KDOWN && posicionJugador[1]!=22){
		stdp.setColor(ABOLD,CWHITE,CBLACK);
		stdp.setCursor(posicionJugador[0],posicionJugador[1]);

		posicionJugador[1]++;

	}
}

void Juego::mostrarDisparo(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);


	for(int i = 0; i<5; i++){
		if(posicionDisparos[i][1]!=23){
			stdp.setCursor(posicionDisparos[i][0],posicionDisparos[i][1]);
			int color = 0;
			color = rand() % 3;
			if(color == 0)
				stdp.setColor(ANORMAL,CWHITE,CBLACK);
			else if(color == 1)
				stdp.setColor(ANORMAL,CRED,CBLACK);
			else if(color == 2)
				stdp.setColor(ANORMAL,CYELLOW,CBLACK);

			if(posicionDisparos[i][2]==0)
				stdp.writeChar('-');
			else
				stdp.writeChar('=');
			if(posicionDisparos[i][0]<79)
				posicionDisparos[i][0]++;
			else{
				numeroDisparos--;
				posicionDisparos[i][0]=1;
				posicionDisparos[i][1]=23;
				disparos[i]=false;
			}

		}
	}
}

void Juego::gestionarDisparo(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	if(tiempoEsperaDisparos==0){
		if(teclapulsada == KSPACE && numeroDisparos < 5){
			numeroDisparos++;
			if(disparos[0]==false){
				numeroDisparoNuevo = 0;
				disparos[0]=true;
			}
			else if(disparos[1]==false){
				numeroDisparoNuevo = 1;
				disparos[1]=true;
			}
			else if(disparos[2]==false){
				numeroDisparoNuevo = 2;
				disparos[2]=true;
			}
			else if(disparos[3]==false){
				numeroDisparoNuevo = 3;
				disparos[3]=true;
			}
			else if(disparos[4]==false){
				numeroDisparoNuevo = 4;
				disparos[4]=true;
			}

			posicionDisparos[numeroDisparoNuevo][0]=posicionJugador[0]+5;
			posicionDisparos[numeroDisparoNuevo][1]=posicionJugador[1];
			if(disparoDoble == false){
				posicionDisparos[numeroDisparoNuevo][2]=0;
			}
			else{
				posicionDisparos[numeroDisparoNuevo][2]=1;
			}
			tiempoEsperaDisparos=25;
		}
	}
	else
		tiempoEsperaDisparos--;

	if(teclapulsada == KBOOM && disparoGrande == true){
		for(int i = 0; i<50; i++){
			if(posicionEnemigos[i][1]!= 23){

				stdp.setCursor(posicionEnemigos[i][0],posicionEnemigos[i][1]);
				stdp.setColor(ANORMAL,CCYAN,CBLACK);
				stdp.writeStr("*Puf*");

				if(posicionEnemigos[i][2]==0)
					puntuacionPartida+=300;
				else if(posicionEnemigos[i][2]==1)
					puntuacionPartida+=200;
				else if(posicionEnemigos[i][2]==2)
					puntuacionPartida+=100;

				posicionEnemigos[i][1]=23;
				posicionEnemigos[i][0]=0;

			}
		}

		stdp.setCursor(35,12);
		stdp.setColor(ANORMAL,CRED,CBLACK);
		stdp.writeStr("KABOOOOOOM");
		stdp.refreshScr();
		sleep(1);
		disparoGrande=false;
	}
}

void Juego::mostrarEnemigo(){

	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);


	for(int i = 0; i<50; i++){
		if(posicionEnemigos[i][1]!=23){
			stdp.setCursor(posicionEnemigos[i][0],posicionEnemigos[i][1]);

			if(posicionEnemigos[i][2]==0){
				stdp.setColor(ANORMAL,CWHITE,CBLACK);

				if(posicionEnemigos[i][0]==79){
					stdp.writeChar('<');
				}
				if(posicionEnemigos[i][0]==78){
					stdp.writeStr("<o");
				}
				if(posicionEnemigos[i][0]<=77){
					stdp.writeStr("<o>");
				}
			}
			else if(posicionEnemigos[i][2]==1){
				stdp.setColor(ANORMAL,CBLUE,CBLACK);

				if(posicionEnemigos[i][0]==79)
					stdp.writeStr("(");
				if(posicionEnemigos[i][0]==78)
					stdp.writeStr("(-");
				if(posicionEnemigos[i][0]==77)
					stdp.writeStr("(-0");
				if(posicionEnemigos[i][0]==76)
					stdp.writeStr("(-0-");
				if(posicionEnemigos[i][0]<=75)
					stdp.writeStr("(-0-)");
			}
			else if(posicionEnemigos[i][2]==2){
				stdp.setColor(ANORMAL,CYELLOW,CBLACK);
				if(posicionEnemigos[i][0]==79)
					stdp.writeStr("{");
				if(posicionEnemigos[i][0]==78)
					stdp.writeStr("{[");
				if(posicionEnemigos[i][0]==77)
					stdp.writeStr("{[=");
				if(posicionEnemigos[i][0]==76)
					stdp.writeStr("{[=0");
				if(posicionEnemigos[i][0]==75)
					stdp.writeStr("{[=0=");
				if(posicionEnemigos[i][0]==74)
					stdp.writeStr("{[=0=]");
				if(posicionEnemigos[i][0]<=73)
					stdp.writeStr("{[=0=]}");
			}

			bool ko = false;
			for(int j = 0; j<5 && ko==false; j++){
				if((posicionEnemigos[i][0]==posicionDisparos[j][0] && posicionEnemigos[i][1]==posicionDisparos[j][1])||(posicionEnemigos[i][0]+1==posicionDisparos[j][0] && posicionEnemigos[i][1]==posicionDisparos[j][1])||(posicionEnemigos[i][0]-1==posicionDisparos[j][0] && posicionEnemigos[i][1]==posicionDisparos[j][1])){
					if(posicionDisparos[j][2]==0){
						numeroDisparos--;
						posicionDisparos[j][0]=1;
						posicionDisparos[j][1]=23;
						disparos[j]=false;
					}

					stdp.setCursor(posicionEnemigos[i][0],posicionEnemigos[i][1]);
					stdp.setColor(ANORMAL,CCYAN,CBLACK);
					stdp.writeStr("*Puf*");


					posicionEnemigos[i][1]=23;
					posicionEnemigos[i][0]=0;

					ko = true;

				}
			}
			if(ko == true)
				navesAbatidas++;
			if(ko == true && posicionEnemigos[i][2]==0)
				puntuacionPartida+=300;
			else if(ko == true && posicionEnemigos[i][2]==1)
				puntuacionPartida+=200;
			else if(ko == true && posicionEnemigos[i][2]==2)
				puntuacionPartida+=100;
		}

		restaVida=false;

		if((posicionEnemigos[i][0]==posicionJugador[0] && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+1==posicionJugador[0] && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+2==posicionJugador[0] && posicionEnemigos[i][1]==posicionJugador[1])){
			if(restaVida==false){
				restaVida=true;
				energia-=25;
				disparoDoble=false;
				disparoGrande=false;
				for(int j = 0; j<9; j++){
					if(j%2==0)
						stdp.setColor(ABOLD,CRED,CBLACK);
					if(j%3==0)
						stdp.setColor(ABOLD,CYELLOW,CBLACK);
					if(j%5==0)
						stdp.setColor(ABOLD,CWHITE,CBLACK);
					if(j%7==0)
						stdp.setColor(ABOLD,CMAGENTA,CBLACK);

					stdp.setCursor(posicionJugador[0],posicionJugador[1]);
					stdp.writeChar('3');
					stdp.writeChar('(');
					stdp.writeStr("oo");
					stdp.writeChar(')');
					stdp.writeChar('{');
					stdp.refreshScr();
					usleep(6000);

				}
				sleep(2);
				for(int i = 0; i<50; i++){
					if(posicionEnemigos[i][1]!= 23){
						posicionEnemigos[i][1]=23;
						posicionEnemigos[i][0]=0;

					}
				}

				posicionJugador[0]=3;
				posicionJugador[1]=13;
			}
		}
		if((posicionEnemigos[i][0]==posicionJugador[0]+1 && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+1==posicionJugador[0]+1 && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+2==posicionJugador[0]+1 && posicionEnemigos[i][1]==posicionJugador[1])){
			if(restaVida==false){
				restaVida=true;
				energia-=25;
				disparoDoble=false;
				disparoGrande=false;
				for(int j = 0; j<9; j++){
					if(j%2==0)
						stdp.setColor(ABOLD,CRED,CBLACK);
					if(j%3==0)
						stdp.setColor(ABOLD,CYELLOW,CBLACK);
					if(j%5==0)
						stdp.setColor(ABOLD,CWHITE,CBLACK);
					if(j%7==0)
						stdp.setColor(ABOLD,CMAGENTA,CBLACK);

					stdp.setCursor(posicionJugador[0],posicionJugador[1]);
					stdp.writeChar('3');
					stdp.writeChar('(');
					stdp.writeStr("oo");
					stdp.writeChar(')');
					stdp.writeChar('{');
					stdp.refreshScr();
					usleep(6000);

				}
				sleep(2);
				for(int i = 0; i<50; i++){
					if(posicionEnemigos[i][1]!= 23){
						posicionEnemigos[i][1]=23;
						posicionEnemigos[i][0]=0;

					}
				}

				posicionJugador[0]=3;
				posicionJugador[1]=13;
			}
		}

		if((posicionEnemigos[i][0]==posicionJugador[0]+3 && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+1==posicionJugador[0]+3 && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+2==posicionJugador[0]+3 && posicionEnemigos[i][1]==posicionJugador[1])){
			if(restaVida==false){
				restaVida=true;
				energia-=25;
				disparoDoble=false;
				disparoGrande=false;
				for(int j = 0; j<9; j++){
					if(j%2==0)
						stdp.setColor(ABOLD,CRED,CBLACK);
					if(j%3==0)
						stdp.setColor(ABOLD,CYELLOW,CBLACK);
					if(j%5==0)
						stdp.setColor(ABOLD,CWHITE,CBLACK);
					if(j%7==0)
						stdp.setColor(ABOLD,CMAGENTA,CBLACK);

					stdp.setCursor(posicionJugador[0],posicionJugador[1]);
					stdp.writeChar('3');
					stdp.writeChar('(');
					stdp.writeStr("oo");
					stdp.writeChar(')');
					stdp.writeChar('{');
					stdp.refreshScr();
					usleep(6000);

				}
				sleep(2);
				for(int i = 0; i<50; i++){
					if(posicionEnemigos[i][1]!= 23){
						posicionEnemigos[i][1]=23;
						posicionEnemigos[i][0]=0;

					}
				}

				posicionJugador[0]=3;
				posicionJugador[1]=13;
			}
		}
		if((posicionEnemigos[i][0]==posicionJugador[0]+4 && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+1==posicionJugador[0]+4 && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+2==posicionJugador[0]+4 && posicionEnemigos[i][1]==posicionJugador[1])){
			if(restaVida==false){
				restaVida=true;
				energia-=25;
				disparoDoble=false;
				disparoGrande=false;
				for(int j = 0; j<9; j++){
					if(j%2==0)
						stdp.setColor(ABOLD,CRED,CBLACK);
					if(j%3==0)
						stdp.setColor(ABOLD,CYELLOW,CBLACK);
					if(j%5==0)
						stdp.setColor(ABOLD,CWHITE,CBLACK);
					if(j%7==0)
						stdp.setColor(ABOLD,CMAGENTA,CBLACK);
					stdp.setCursor(posicionJugador[0],posicionJugador[1]);
					stdp.writeChar('3');
					stdp.writeChar('(');
					stdp.writeStr("oo");
					stdp.writeChar(')');
					stdp.writeChar('{');
					stdp.refreshScr();
					usleep(6000);

				}
				sleep(2);
				for(int i = 0; i<50; i++){
					if(posicionEnemigos[i][1]!= 23){
						posicionEnemigos[i][1]=23;
						posicionEnemigos[i][0]=0;

					}
				}

				posicionJugador[0]=3;
				posicionJugador[1]=13;
			}
		}
		if((posicionEnemigos[i][0]==posicionJugador[0]+5 && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+1==posicionJugador[0]+5 && posicionEnemigos[i][1]==posicionJugador[1])||(posicionEnemigos[i][0]+2==posicionJugador[0]+5 && posicionEnemigos[i][1]==posicionJugador[1])){
			if(restaVida==false){
				restaVida=true;
				energia-=25;
				disparoDoble=false;
				disparoGrande=false;
				for(int j = 0; j<9; j++){
					if(j%2==0)
						stdp.setColor(ABOLD,CRED,CBLACK);
					if(j%3==0)
						stdp.setColor(ABOLD,CYELLOW,CBLACK);
					if(j%5==0)
						stdp.setColor(ABOLD,CWHITE,CBLACK);
					if(j%7==0)
						stdp.setColor(ABOLD,CMAGENTA,CBLACK);

					stdp.setCursor(posicionJugador[0],posicionJugador[1]);
					stdp.writeChar('3');
					stdp.writeChar('(');
					stdp.writeStr("oo");
					stdp.writeChar(')');
					stdp.writeChar('{');
					stdp.refreshScr();
					usleep(6000);

				}
				sleep(2);
				for(int i = 0; i<50; i++){
					if(posicionEnemigos[i][1]!= 23){
						posicionEnemigos[i][1]=23;
						posicionEnemigos[i][0]=0;

					}
				}

				posicionJugador[0]=3;
				posicionJugador[1]=13;
			}
		}

		if(posicionEnemigos[i][2]==1){
			if((posicionEnemigos[i][0]+3==posicionJugador[0] && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0] && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
			if((posicionEnemigos[i][0]+3==posicionJugador[0]+1 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+1 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}

			if((posicionEnemigos[i][0]+3==posicionJugador[0]+2 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+2 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
			if((posicionEnemigos[i][0]+3==posicionJugador[0]+3 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+3 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);
						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
			if((posicionEnemigos[i][0]+3==posicionJugador[0]+4 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+4 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
			if((posicionEnemigos[i][0]+3==posicionJugador[0]+5 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+5 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
		}
		if(posicionEnemigos[i][2]==2){
			if((posicionEnemigos[i][0]+3==posicionJugador[0] && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0] && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+5==posicionJugador[0] && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+6==posicionJugador[0] && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
			if((posicionEnemigos[i][0]+3==posicionJugador[0]+1 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+1 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+5==posicionJugador[0]+1 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+6==posicionJugador[0]+1 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}

			if((posicionEnemigos[i][0]+3==posicionJugador[0]+2 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+2 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+5==posicionJugador[0]+2 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+6==posicionJugador[0]+2 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
			if((posicionEnemigos[i][0]+3==posicionJugador[0]+3 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+3 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+5==posicionJugador[0]+3 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+6==posicionJugador[0]+3 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);
						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
			if((posicionEnemigos[i][0]+3==posicionJugador[0]+4 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+4 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+5==posicionJugador[0]+4 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+6==posicionJugador[0]+4 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
			if((posicionEnemigos[i][0]+3==posicionJugador[0]+5 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+4==posicionJugador[0]+5 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+5==posicionJugador[0]+5 && posicionEnemigos[i][1]==posicionJugador[1]) || (posicionEnemigos[i][0]+6==posicionJugador[0]+5 && posicionEnemigos[i][1]==posicionJugador[1])){
				if(restaVida==false){
					restaVida=true;
					energia-=25;
					disparoDoble=false;
					disparoGrande=false;
					for(int j = 0; j<9; j++){
						if(j%2==0)
							stdp.setColor(ABOLD,CRED,CBLACK);
						if(j%3==0)
							stdp.setColor(ABOLD,CYELLOW,CBLACK);
						if(j%5==0)
							stdp.setColor(ABOLD,CWHITE,CBLACK);
						if(j%7==0)
							stdp.setColor(ABOLD,CMAGENTA,CBLACK);

						stdp.setCursor(posicionJugador[0],posicionJugador[1]);
						stdp.writeChar('3');
						stdp.writeChar('(');
						stdp.writeStr("oo");
						stdp.writeChar(')');
						stdp.writeChar('{');
						stdp.refreshScr();
						usleep(6000);

					}
					sleep(2);
					for(int i = 0; i<50; i++){
						if(posicionEnemigos[i][1]!= 23){
							posicionEnemigos[i][1]=23;
							posicionEnemigos[i][0]=0;

						}
					}

					posicionJugador[0]=3;
					posicionJugador[1]=13;
				}
			}
		}
	}


	for(int i = 0; i<50; i++){
		if(posicionEnemigos[i][1]!=23 && posicionEnemigos[i][0]!=0){
			if(posicionEnemigos[i][2]==0 && tiempoEsperaRapidos == 0){
				posicionEnemigos[i][0]--;
			}

			if(posicionEnemigos[i][2]==2 && tiempoEsperaLentos == 0){
				posicionEnemigos[i][0]--;
			}

			if(posicionEnemigos[i][2]==1 && tiempoEsperaNormales == 0){
				posicionEnemigos[i][0]--;
			}
		}
		if(posicionEnemigos[i][0]==0)
			posicionEnemigos[i][1]=23;
	}

	if(tiempoEsperaRapidos==0)
		tiempoEsperaRapidos=7;
	if(tiempoEsperaLentos==0)
		tiempoEsperaLentos=20;
	if(tiempoEsperaNormales==0)
		tiempoEsperaNormales=13;
	tiempoEsperaRapidos--;
	tiempoEsperaLentos--;
	tiempoEsperaNormales--;



}

void Juego::gestionarEnemigo(){

	int activacion;
	activacion = rand() % (250-((nivelActual-1)*5));
	if(activacion == 0)
	{
		int i;
		bool check = false;
		for(i=0;i<50 && check == false;i++){
			if(posicionEnemigos[i][1]==23)
				check=true;
		}
		i--;

		posicionEnemigos[i][1]=rand() % 23;
		posicionEnemigos[i][0]=79;
		posicionEnemigos[i][2]=rand() % 3;
	}

}

void Juego::mostrarObjetos(){

	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);


	for(int i = 0; i<15; i++){
		if(posicionObjetos[i][1]!=23){
			stdp.setCursor(posicionObjetos[i][0],posicionObjetos[i][1]);

			if(posicionObjetos[i][2]==0){
				stdp.setColor(ANORMAL,CWHITE,CBLACK);

				if(posicionObjetos[i][0]==79){
					stdp.writeChar('(');
				}
				if(posicionObjetos[i][0]==78){
					stdp.writeStr("(=");
				}
				if(posicionObjetos[i][0]<=77){
					stdp.writeStr("(=)");
				}
			}
			else if(posicionObjetos[i][2]==1){
				stdp.setColor(ANORMAL,CBLUE,CBLACK);

				if(posicionObjetos[i][0]==79)
					stdp.writeStr("(");
				if(posicionObjetos[i][0]==78)
					stdp.writeStr("(B");
				if(posicionObjetos[i][0]<=77)
					stdp.writeStr("(B)");
			}

			else if(posicionObjetos[i][2]==2){
				stdp.setColor(ANORMAL,CBLUE,CBLACK);

				if(posicionObjetos[i][0]==79)
					stdp.writeStr("(");
				if(posicionObjetos[i][0]==78)
					stdp.writeStr("(E");
				if(posicionObjetos[i][0]<=77)
					stdp.writeStr("(E)");
			}

			bool ko = false;
			for(int j = 0; j<5 && ko==false; j++){
				if((posicionObjetos[i][0]==posicionDisparos[j][0] && posicionObjetos[i][1]==posicionDisparos[j][1])||(posicionObjetos[i][0]+1==posicionDisparos[j][0] && posicionObjetos[i][1]==posicionDisparos[j][1])||(posicionObjetos[i][0]-1==posicionDisparos[j][0] && posicionObjetos[i][1]==posicionDisparos[j][1])){
					numeroDisparos--;
					posicionDisparos[j][0]=1;
					posicionDisparos[j][1]=23;
					disparos[j]=false;

					stdp.setCursor(posicionObjetos[i][0],posicionObjetos[i][1]);
					stdp.setColor(ANORMAL,CCYAN,CBLACK);
					stdp.writeStr("*Puf*");


					posicionObjetos[i][1]=23;
					posicionObjetos[i][0]=0;

					ko = true;

				}
			}

			if((posicionObjetos[i][0]==posicionJugador[0] && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+1==posicionJugador[0] && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+2==posicionJugador[0] && posicionObjetos[i][1]==posicionJugador[1])){
				stdp.setCursor(posicionObjetos[i][0],posicionObjetos[i][1]);
				stdp.setColor(ANORMAL,CCYAN,CBLACK);
				stdp.writeStr("*Puf*");

				posicionObjetos[i][1]=23;

				ko = true;
			}
			if((posicionObjetos[i][0]==posicionJugador[0]+1 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+1==posicionJugador[0]+1 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+2==posicionJugador[0]+1 && posicionObjetos[i][1]==posicionJugador[1])){
				stdp.setCursor(posicionObjetos[i][0],posicionObjetos[i][1]);
				stdp.setColor(ANORMAL,CCYAN,CBLACK);
				stdp.writeStr("*Puf*");

				posicionObjetos[i][1]=23;

				ko = true;
			}
			if((posicionObjetos[i][0]==posicionJugador[0]+2 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+1==posicionJugador[0]+2 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+2==posicionJugador[0]+2 && posicionObjetos[i][1]==posicionJugador[1])){
				stdp.setCursor(posicionObjetos[i][0],posicionObjetos[i][1]);
				stdp.setColor(ANORMAL,CCYAN,CBLACK);
				stdp.writeStr("*Puf*");

				posicionObjetos[i][1]=23;

				ko = true;
			}
			if((posicionObjetos[i][0]==posicionJugador[0]+3 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+1==posicionJugador[0]+3 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+2==posicionJugador[0]+3 && posicionObjetos[i][1]==posicionJugador[1])){
				stdp.setCursor(posicionObjetos[i][0],posicionObjetos[i][1]);
				stdp.setColor(ANORMAL,CCYAN,CBLACK);
				stdp.writeStr("*Puf*");

				posicionObjetos[i][1]=23;

				ko = true;
			}
			if((posicionObjetos[i][0]==posicionJugador[0]+4 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+1==posicionJugador[0]+4 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+2==posicionJugador[0]+4 && posicionObjetos[i][1]==posicionJugador[1])){
				stdp.setCursor(posicionObjetos[i][0],posicionObjetos[i][1]);
				stdp.setColor(ANORMAL,CCYAN,CBLACK);
				stdp.writeStr("*Puf*");

				posicionObjetos[i][1]=23;

				ko = true;
			}
			if((posicionObjetos[i][0]==posicionJugador[0]+5 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+1==posicionJugador[0]+5 && posicionObjetos[i][1]==posicionJugador[1])||(posicionObjetos[i][0]+2==posicionJugador[0]+5 && posicionObjetos[i][1]==posicionJugador[1])){

			stdp.setCursor(posicionObjetos[i][0],posicionObjetos[i][1]);
			stdp.setColor(ANORMAL,CCYAN,CBLACK);
			stdp.writeStr("*Puf*");

			posicionObjetos[i][1]=23;

			ko = true;
			}
			if(ko == true && posicionObjetos[i][2]==0)
				disparoDoble=true;
			else if(ko == true && posicionObjetos[i][2]==1)
				disparoGrande=true;
			else if(ko == true && posicionObjetos[i][2]==2){
				if(energia < 100)
					energia+=25;
			}
		}
	}

	for(int i = 0; i<15; i++){
		if(posicionObjetos[i][1]!=23 && posicionObjetos[i][0]!=0){
			posicionObjetos[i][0]--;
		}
		if(posicionObjetos[i][0]==0)
			posicionObjetos[i][1]=23;
	}
}

void Juego::gestionarObjetos(){

	int activacion;
	activacion = rand() % 30000;
	if(activacion == 1)
	{
		int i;
		bool check = false;
		for(i=0;i<15 && check == false;i++){
			if(posicionObjetos[i][1]==23)
				check=true;
		}
		i--;

		posicionObjetos[i][1]=rand() % 23;
		posicionObjetos[i][0]=79;
		posicionObjetos[i][2]=rand() % 3;

		if(disparoDoble == true && posicionObjetos[i][2]== 0)
			posicionObjetos[i][1]=23;
		if(disparoGrande == true && posicionObjetos[i][2]==1)
			posicionObjetos[i][1]=23;
		if(energia == 100 && posicionObjetos[i][2]==2)
			posicionObjetos[i][1]=23;


	}
}


