#ifndef JUEGO_H_
#define JUEGO_H_

// Incluimos la cabecera principal de StdPijo
#include "StdPijo.h"

#include <iostream>

// Incluimos cabeceras para números aleatorios y retardos
#include <ctime>
#include <cstdlib>
#include <unistd.h>
#include <sys/time.h>

#include "string.h"

using namespace std;

class Juego{
private:
	int nivelActual; //Variable que guarda el nivel en el que se encuentra la partida
	int puntuacionPartida; //Variable que guarda la puntuación en ese momento
	static const int incrementoNaves = 10; //Constante que guarda el número de minas que se incrementa en cada nivel
	int navesParaAbatir; //Naves que hay que abatir para pasar del nivel actual
	int navesAbatidas; //Número de naves que se han abatido
	int modoSeleccionado; //Modo seleccionado (0 normal, 1 con objetos)
	int posicionJugador[2]; //Posición en coordenadas del personaje a controlar
	int vidas; //Número de vidas restante de la nave
	int energia; //Cantidad de energía de la nave antes de perder una vida
	bool disparoDoble;
	bool disparoGrande;
	int tiempoEsperaDisparos;
	int posicionDisparos[5][3];
	int numeroDisparoNuevo;
	int numeroDisparos;
	bool disparos[5];
	int teclapulsada;
	int tiempoEsperaBackground;
	int posicionEstrellas[50][2];
	int posicionEnemigos[50][3];
	int posicionObjetos[15][3];
	int tiempoEsperaLentos;
	int tiempoEsperaRapidos;
	int tiempoEsperaNormales;
	bool restaVida;


public:
	Juego(){
		nivelActual=1;
		puntuacionPartida=0;
		navesParaAbatir=0;
		navesAbatidas=0;
		modoSeleccionado=0;
		posicionJugador[0]=3;
		posicionJugador[1]=13;
		vidas = 3;
		energia = 100;
		disparoDoble = false;
		disparoGrande = false;
		tiempoEsperaDisparos = 0;

		for(int i = 0; i<5;i++){
			posicionDisparos[i][0]=0;
			posicionDisparos[i][1]=23;
			posicionDisparos[i][2]=0;
			disparos[i]=false;
		}


		for(int i = 0; i<50;i++){
			posicionEnemigos[i][0]=0;
			posicionEnemigos[i][1]=0;
			posicionEnemigos[i][2]=0;
		}

		for(int i = 0; i<15;i++){
			posicionObjetos[i][0]=0;
			posicionObjetos[i][1]=0;
			posicionObjetos[i][2]=0;
		}
		numeroDisparos=0;
		teclapulsada=0;
		tiempoEsperaBackground = 0;

		tiempoEsperaLentos=0;
		tiempoEsperaRapidos=0;
		tiempoEsperaNormales=0;
		restaVida=false;
	}

	void iniciarJuego(int modo); //Se inicia el juego
	void mostrarCuentaAtras(); //Muestra la cuentra atrás antes de empezar a jugar
	void mostrarEnergia(); //Muestra el bonus por pantalla
	void mostrarPuntuacion(); //Muestra la puntuación por pantalla
	void generarBackgroundAleatorio();
	void mostrarBackground(); //Muestra el campo de minas
	void controlPersonaje(); //Controla los diferentes sucesos del personaje con las minas y los objetos
	void mostrarEnemigos(); //Muestra las minas en el campo de minas
	void mostrarObjetos();
	void mostrarDisparo();
	void gestionarDisparo();
	void mostrarEnemigo();
	void gestionarEnemigo();
	void gestionarObjetos();
	int getPuntuacion() const{return puntuacionPartida;}
	int getNivel() const{return nivelActual;}
};


#endif /* JUEGO_H_ */
